package io.repro.flutter;

import java.util.Locale;
import java.util.Map;
import java.util.HashMap;
import java.text.SimpleDateFormat;
import io.repro.android.newsfeed.NewsFeedEntry;
import io.repro.android.newsfeed.NewsFeedCampaignType;


class NewsFeedUtils {

    static Map<String, String> convertToMap(NewsFeedEntry entry) {
        Map<String, String> map = new HashMap<>();
        map.put("id", String.valueOf(entry.id));
        map.put("campaignType", entry.campaignType.toString());
        map.put("deviceID", entry.deviceID);
        map.put("title", entry.title);
        map.put("summary", entry.summary);
        map.put("body", entry.body);

        if (entry.linkUrl != null) {
            String url = entry.linkUrl.toString();
            map.put("linkUrl", "null".equals(url) ? null : url);
        }

        if (entry.imageUrl != null) {
            String url = entry.imageUrl.toString();
            map.put("imageUrl", "null".equals(url) ? null : url);
        }

        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ssZ", Locale.US);
        map.put("deliveredAt", format.format(entry.deliveredAt));
        
        map.put("shown", String.valueOf(entry.shown));
        map.put("read", String.valueOf(entry.read));

        return map;
    }
}
